commit:     62d0dc13d15389c1332eed076ab9214879743258
Author:     David Seifert <soap <AT> gentoo <DOT> org>
AuthorDate: Tue Feb 21 20:29:11 2023 +0000
Commit:     David Seifert <soap <AT> gentoo <DOT> org>
CommitDate: Tue Feb 21 20:29:11 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=62d0dc13

sys-fs/lvm2: add 2.03.19

Signed-off-by: David Seifert <soap <AT> gentoo.org>

 sys-fs/lvm2/Manifest                               |   1 +
 .../lvm2-2.03.19-dm_lvm_rules_no_systemd.patch     |  11 +
 .../files/lvm2-2.03.19-dmeventd-no-idle-exit.patch |  73 +++++
 .../lvm2-2.03.19-dynamic-static-ldflags.patch      |  50 ++++
 sys-fs/lvm2/files/lvm2-2.03.19-freopen-musl.patch  |  63 +++++
 .../files/lvm2-2.03.19-static-pkgconfig-libs.patch | 130 +++++++++
 sys-fs/lvm2/lvm2-2.03.19.ebuild                    | 306 +++++++++++++++++++++
 7 files changed, 634 insertions(+)

diff --git a/sys-fs/lvm2/Manifest b/sys-fs/lvm2/Manifest
index b7ce1cc25e6d..c1c32f79b536 100644
--- a/sys-fs/lvm2/Manifest
+++ b/sys-fs/lvm2/Manifest
@@ -1,2 +1,3 @@
 DIST LVM2.2.03.17.tgz 2726793 BLAKE2B 
425e52fe2d7832f8440203d2b6ffc3a097903abea8be07bbbf4864001d5f55083954e561a92b0fe4fc467533e465af3958b25cf33d2693f50f077dc3d9b74bd2
 SHA512 
ce9f4c10a7e89b397fa021098976117c062227da4f25996296dd3678c0aeb826edf9b7e4f5d3992f42156865ae47cb98671ec37a26868710174a473b42cc70a9
 DIST LVM2.2.03.18.tgz 2728113 BLAKE2B 
59df1a6ece11473d3f15a8b81701faa363be556f7668a34d2cbbf9221a014f268c230f08d3bd873bbebee89480c787a6f358b2edf8777c990c62e7c6a36aecad
 SHA512 
58043bdcad882065f15d772401d29fc7fb2d0a6b6b75063915dc38bb11cd847517dd18ae7e2acb3935e6c32ef620a275c2b2b9c307434f7457ea3203b87254c1
+DIST LVM2.2.03.19.tgz 2732219 BLAKE2B 
7a5bd024312f149d95361ea24a282c8c68e371687fe8f7c853fa0748ce854bc991cdade999835666a5ece569e80dd9be85d4fae7fc5cc75b912de00f170cf66e
 SHA512 
a40691f6f4c9300c95784be0fcb055a2b8e07bfdc87f000f2357ccb54fdb814a679fb79f5c9790a7440ef538e9997e46d56e539814bfdf138b4e76603aeb2994

diff --git a/sys-fs/lvm2/files/lvm2-2.03.19-dm_lvm_rules_no_systemd.patch 
b/sys-fs/lvm2/files/lvm2-2.03.19-dm_lvm_rules_no_systemd.patch
new file mode 100644
index 000000000000..e39d7959b331
--- /dev/null
+++ b/sys-fs/lvm2/files/lvm2-2.03.19-dm_lvm_rules_no_systemd.patch
@@ -0,0 +1,11 @@
+--- a/udev/69-dm-lvm.rules.in
++++ b/udev/69-dm-lvm.rules.in
+@@ -76,7 +76,7 @@
+ # it's better suited to appearing in the journal.
+ 
+ IMPORT{program}="(LVM_EXEC)/lvm pvscan --cache --listvg --checkcomplete 
--vgonline --autoactivation event --udevoutput --journal=output $env{DEVNAME}"
+-ENV{LVM_VG_NAME_COMPLETE}=="?*", RUN+="(SYSTEMDRUN) --no-block --property 
DefaultDependencies=no --unit lvm-activate-$env{LVM_VG_NAME_COMPLETE} 
(LVM_EXEC)/lvm vgchange -aay --autoactivation event $env{LVM_VG_NAME_COMPLETE}"
++ENV{LVM_VG_NAME_COMPLETE}=="?*", RUN+="(LVM_EXEC)/lvm vgchange -aay --nohints 
--autoactivation event $env{LVM_VG_NAME_COMPLETE}"
+ GOTO="lvm_end"
+ 
+ LABEL="lvm_end"

diff --git a/sys-fs/lvm2/files/lvm2-2.03.19-dmeventd-no-idle-exit.patch 
b/sys-fs/lvm2/files/lvm2-2.03.19-dmeventd-no-idle-exit.patch
new file mode 100644
index 000000000000..b7030ccc084d
--- /dev/null
+++ b/sys-fs/lvm2/files/lvm2-2.03.19-dmeventd-no-idle-exit.patch
@@ -0,0 +1,73 @@
+From ab3ae0a22dfbe20e2d17e7dc60e0f76184ec098c Mon Sep 17 00:00:00 2001
+From: "Robin H. Johnson" <[email protected]>
+Date: Wed, 24 Jul 2019 11:22:32 +0200
+Subject: [PATCH] dmeventd configurable idle exit time
+
+dmeventd nominally exits after 1 hour of idle time. There are use cases for
+this, esp. with socket activation, but also cases where users don't expect
+dmeventd to exit.
+
+Provide a tuning knob via environment variable, DMEVENTD_IDLE_EXIT_TIMEOUT,
+that can be -1 to not exit, or a configurable time for different idle exit.
+
+Signed-off-by: Robin H. Johnson <[email protected]>
+Fixes: https://bugs.gentoo.org/682556
+---
+ daemons/dmeventd/dmeventd.c | 16 ++++++++++++++--
+ man/dmeventd.8_main         |  4 ++++
+ 2 files changed, 18 insertions(+), 2 deletions(-)
+
+diff --git a/daemons/dmeventd/dmeventd.c b/daemons/dmeventd/dmeventd.c
+index 33859ef414..ac0b9743fc 100644
+--- a/daemons/dmeventd/dmeventd.c
++++ b/daemons/dmeventd/dmeventd.c
+@@ -2169,6 +2169,18 @@
+               .server_path = DM_EVENT_FIFO_SERVER
+       };
+       time_t now, idle_exit_timeout = DMEVENTD_IDLE_EXIT_TIMEOUT;
++
++      /* Provide a basic way to config the idle timeout */
++      char* idle_exit_timeout_env = getenv("DMEVENTD_IDLE_EXIT_TIMEOUT") ? : 
NULL;
++      if(NULL != idle_exit_timeout_env) {
++              char* endptr;
++              idle_exit_timeout = strtol(idle_exit_timeout_env, &endptr, 10);
++              if (errno == ERANGE || *endptr != '\0') {
++                      fprintf(stderr, "DMEVENTD_IDLE_EXIT_TIMEOUT: bad time 
input\n");
++                      exit(EXIT_FAILURE);
++              }
++      }
++
+       opterr = 0;
+       optind = 0;
+ 
+@@ -2265,7 +2277,7 @@
+               _process_initial_registrations();
+ 
+       for (;;) {
+-              if (_idle_since) {
++              if (_idle_since || _exit_now) {
+                       if (_exit_now) {
+                               if (_exit_now == DM_SCHEDULED_EXIT)
+                                       break; /* Only prints shutdown message 
*/
+@@ -2274,7 +2286,7 @@
+                                        (long) (time(NULL) - _idle_since));
+                               break;
+                       }
+-                      if (idle_exit_timeout) {
++                      if (idle_exit_timeout && idle_exit_timeout > 0) {
+                               now = time(NULL);
+                               if (now < _idle_since)
+                                       _idle_since = now; /* clock change? */
+--- a/man/dmeventd.8_main
++++ b/man/dmeventd.8_main
+@@ -169,6 +169,10 @@
+ Variable is set by thin and vdo plugin to prohibit recursive interaction
+ with dmeventd by any executed lvm2 command from
+ a thin_command, vdo_command environment.
++.TP
++.B DMEVENTD_IDLE_EXIT_TIMEOUT
++Configure the dmeventd idle exit timeout behavior, value in seconds. Default
++is 3600 (1 hour). -1 means do not exit.
+ .
+ .SH SEE ALSO
+ .

diff --git a/sys-fs/lvm2/files/lvm2-2.03.19-dynamic-static-ldflags.patch 
b/sys-fs/lvm2/files/lvm2-2.03.19-dynamic-static-ldflags.patch
new file mode 100644
index 000000000000..3aae81984506
--- /dev/null
+++ b/sys-fs/lvm2/files/lvm2-2.03.19-dynamic-static-ldflags.patch
@@ -0,0 +1,50 @@
+--- a/configure.ac
++++ b/configure.ac
+@@ -32,6 +32,7 @@
+       [linux*], [
+               # equivalent to -rdynamic
+               ELDFLAGS="-Wl,--export-dynamic"
++              STATIC_LDFLAGS="-Wl,--no-export-dynamic"
+               # FIXME Generate list and use --dynamic-list=.dlopen.sym
+               CLDWHOLEARCHIVE="-Wl,-whole-archive"
+               CLDNOWHOLEARCHIVE="-Wl,-no-whole-archive"
+@@ -1875,6 +1876,7 @@
+ AC_SUBST(SYSTEMD_RUN_CMD)
+ AC_SUBST(SNAPSHOTS)
+ AC_SUBST(STATICDIR)
++AC_SUBST(STATIC_LDFLAGS)
+ AC_SUBST(STATIC_LINK)
+ AC_SUBST(TESTSUITE_DATA)
+ AC_SUBST(THIN)
+--- a/daemons/dmeventd/Makefile.in
++++ b/daemons/dmeventd/Makefile.in
+@@ -76,7 +76,7 @@
+ 
+ dmeventd.static: $(LIB_STATIC) dmeventd.o
+       @echo "    [CC] $@"
+-      $(Q) $(CC) $(CFLAGS) $(LDFLAGS) -static dmeventd.o \
++      $(Q) $(CC) $(CFLAGS) $(LDFLAGS) $(STATIC_LDFLAGS) -static dmeventd.o \
+               -o $@ $(DL_LIBS) $(DMEVENT_LIBS) $(LIBS) $(STATIC_LIBS)
+ 
+ ifeq ("@PKGCONFIG@", "yes")
+--- a/make.tmpl.in
++++ b/make.tmpl.in
+@@ -65,6 +65,7 @@
+ CFLAGS ?= @COPTIMISE_FLAG@ @CFLAGS@
+ CPPFLAGS ?= @CPPFLAGS@
+ LDFLAGS ?= @LDFLAGS@
++STATIC_LDFLAGS += @STATIC_LDFLAGS@
+ CLDFLAGS += @CLDFLAGS@
+ ELDFLAGS += @ELDFLAGS@
+ LDDEPS += @LDDEPS@
+--- a/tools/Makefile.in
++++ b/tools/Makefile.in
+@@ -137,7 +137,7 @@
+ 
+ lvm.static: $(OBJECTS) lvm-static.o $(LVMINTERNAL_LIBS)
+       @echo "    [CC] $@"
+-      $(Q) $(CC) $(CFLAGS) $(LDFLAGS) -static -L$(interfacebuilddir) \
++      $(Q) $(CC) $(CFLAGS) $(LDFLAGS) $(STATIC_LDFLAGS) -static 
-L$(interfacebuilddir) \
+               -o $@ $+ $(LVMLIBS) $(STATIC_LIBS)
+ 
+ liblvm2cmd.a: $(top_builddir)/lib/liblvm-internal.a $(OBJECTS) lvmcmdlib.o 
lvm2cmd.o

diff --git a/sys-fs/lvm2/files/lvm2-2.03.19-freopen-musl.patch 
b/sys-fs/lvm2/files/lvm2-2.03.19-freopen-musl.patch
new file mode 100644
index 000000000000..cc231d9251bd
--- /dev/null
+++ b/sys-fs/lvm2/files/lvm2-2.03.19-freopen-musl.patch
@@ -0,0 +1,63 @@
+From 4cf08811e112100a2b10c60047f3c537ad21d674 Mon Sep 17 00:00:00 2001
+From: David Seifert <[email protected]>
+Date: Sat, 28 Jan 2023 14:22:42 +0100
+Subject: [PATCH] Use `freopen()` on {stdin,stdout,stderr}
+
+* ISO C does not guarantee that the standard streams are modifiable
+  lvalues. Glibc even calls out this behaviour as non-portable:
+    https://www.gnu.org/software/libc/manual/html_node/Standard-Streams.html
+---
+ lib/log/log.c      | 4 ++++
+ tools/lvmcmdline.c | 6 +++---
+ 2 files changed, 7 insertions(+), 3 deletions(-)
+
+diff --git a/lib/log/log.c b/lib/log/log.c
+index 118a3ba42..a94016d81 100644
+--- a/lib/log/log.c
++++ b/lib/log/log.c
+@@ -208,7 +208,11 @@ int reopen_standard_stream(FILE **stream, const char 
*mode)
+ 
+       _check_and_replace_standard_log_streams(old_stream, new_stream);
+ 
++#ifdef __GLIBC__
+       *stream = new_stream;
++#else
++      freopen(NULL, mode, *stream);
++#endif
+       return 1;
+ }
+ 
+diff --git a/tools/lvmcmdline.c b/tools/lvmcmdline.c
+index a5bb6a5c5..0ebfa375c 100644
+--- a/tools/lvmcmdline.c
++++ b/tools/lvmcmdline.c
+@@ -3422,7 +3422,7 @@ static int _check_standard_fds(void)
+       int err = is_valid_fd(STDERR_FILENO);
+ 
+       if (!is_valid_fd(STDIN_FILENO) &&
+-          !(stdin = fopen(_PATH_DEVNULL, "r"))) {
++          !freopen(_PATH_DEVNULL, "r", stdin)) {
+               if (err)
+                       perror("stdin stream open");
+               else
+@@ -3432,7 +3432,7 @@ static int _check_standard_fds(void)
+       }
+ 
+       if (!is_valid_fd(STDOUT_FILENO) &&
+-          !(stdout = fopen(_PATH_DEVNULL, "w"))) {
++          !freopen(_PATH_DEVNULL, "w", stdout)) {
+               if (err)
+                       perror("stdout stream open");
+               /* else no stdout */
+@@ -3440,7 +3440,7 @@ static int _check_standard_fds(void)
+       }
+ 
+       if (!is_valid_fd(STDERR_FILENO) &&
+-          !(stderr = fopen(_PATH_DEVNULL, "w"))) {
++          !freopen(_PATH_DEVNULL, "w", stderr)) {
+               printf("stderr stream open: %s\n",
+                      strerror(errno));
+               return 0;
+-- 
+2.39.2
+

diff --git a/sys-fs/lvm2/files/lvm2-2.03.19-static-pkgconfig-libs.patch 
b/sys-fs/lvm2/files/lvm2-2.03.19-static-pkgconfig-libs.patch
new file mode 100644
index 000000000000..52f2cc0cb7fe
--- /dev/null
+++ b/sys-fs/lvm2/files/lvm2-2.03.19-static-pkgconfig-libs.patch
@@ -0,0 +1,130 @@
+From ac7cce039825ff779795b5c2ae0ecf00ba43a401 Mon Sep 17 00:00:00 2001
+From: "Robin H. Johnson" <[email protected]>
+Date: Sun, 9 May 2021 11:00:22 +0200
+Subject: [PATCH] Use pkgconfig to detect static libs
+
+--- a/configure.ac
++++ b/configure.ac
+@@ -1139,6 +1139,7 @@
+       AS_IF([test "$HAVE_BLKID" = "yes"], [
+               BLKID_WIPING="yes"
+               BLKID_PC="blkid"
++              BLKID_STATIC_LIBS=`$PKG_CONFIG --static --libs $BLKID_PC`
+               DEFAULT_USE_BLKID_WIPING=1
+               AC_DEFINE([BLKID_WIPING_SUPPORT], 1, [Define to 1 to use 
libblkid detection of signatures when wiping.])
+       ], [
+@@ -1165,6 +1166,7 @@
+ 
+ AS_IF([test "$UDEV_SYNC" = "yes"], [
+       PKG_CHECK_MODULES(UDEV, libudev >= 143, [UDEV_PC="libudev"])
++      UDEV_STATIC_LIBS=`$PKG_CONFIG --static --libs libudev`
+       AC_DEFINE([UDEV_SYNC_SUPPORT], 1, [Define to 1 to enable 
synchronisation with udev processing.])
+ 
+       AC_CHECK_LIB(udev, udev_device_get_is_initialized, 
AC_DEFINE([HAVE_LIBUDEV_UDEV_DEVICE_GET_IS_INITIALIZED], 1,
+@@ -1382,19 +1384,28 @@
+ AS_IF([test "$SELINUX" = "yes"], [
+       AC_CHECK_LIB([sepol], [sepol_check_context], [
+               AC_DEFINE([HAVE_SEPOL], 1, [Define to 1 if sepol_check_context 
is available.])
+-              SELINUX_LIBS="-lsepol"])
++              SEPOL_LIBS="-lsepol"])
++
++      PKG_CHECK_MODULES(SELINUX, libselinux, [
++              SELINUX_PC="libselinux"
++              SELINUX_STATIC_LIBS=`$PKG_CONFIG --static --libs libselinux`
++              SELINUX_LIBS="$SELINUX_LIBS $SEPOL_LIBS"
++              AC_DEFINE([HAVE_SELINUX], 1, [Define to 1 to include support 
for selinux.])
++      ], [
++              dnl -- old non-pkgconfig method, is buggy with static builds
+ 
+       AC_CHECK_LIB([selinux], [is_selinux_enabled], [
+               AC_CHECK_HEADERS([selinux/selinux.h],, hard_bailout)
+               AC_CHECK_HEADERS([selinux/label.h])
+               AC_DEFINE([HAVE_SELINUX], 1, [Define to 1 to include support 
for selinux.])
+-              SELINUX_LIBS="-lselinux $SELINUX_LIBS"
++              SELINUX_LIBS="-lselinux $SEPOL_LIBS"
+               SELINUX_PC="libselinux"
+               HAVE_SELINUX=yes ], [
+               AC_MSG_WARN(Disabling selinux)
+               SELINUX_LIBS=
+               SELINUX_PC=
+               HAVE_SELINUX=no ])
++      ])
+ ])
+ 
+ 
################################################################################
+@@ -1790,6 +1801,7 @@
+ 
################################################################################
+ AC_SUBST(AWK)
+ AC_SUBST(BLKID_PC)
++AC_SUBST(BLKID_STATIC_LIBS)
+ AC_SUBST(BUILD_CMIRRORD)
+ AC_SUBST(BUILD_DMEVENTD)
+ AC_SUBST(BUILD_LVMDBUSD)
+@@ -1872,6 +1884,7 @@
+ AC_SUBST(SBINDIR)
+ AC_SUBST(SELINUX_LIBS)
+ AC_SUBST(SELINUX_PC)
++AC_SUBST(SELINUX_STATIC_LIBS)
+ AC_SUBST(SYSCONFDIR)
+ AC_SUBST(SYSTEMD_RUN_CMD)
+ AC_SUBST(SNAPSHOTS)
+@@ -1890,6 +1903,7 @@
+ AC_SUBST(CACHE_RESTORE_CMD)
+ AC_SUBST(UDEV_PC)
+ AC_SUBST(UDEV_RULES)
++AC_SUBST(UDEV_STATIC_LIBS)
+ AC_SUBST(UDEV_SYNC)
+ AC_SUBST(UDEV_RULE_EXEC_DETECTION)
+ AC_SUBST(UDEV_HAS_BUILTIN_BLKID)
+--- a/libdm/make.tmpl.in
++++ b/libdm/make.tmpl.in
+@@ -54,7 +54,7 @@
+ 
+ LIBS += @LIBS@ $(PTHREAD_LIBS) $(SELINUX_LIBS) $(UDEV_LIBS) $(RT_LIBS) 
$(M_LIBS)
+ # Extra libraries always linked with static binaries
+-STATIC_LIBS = $(PTHREAD_LIBS)
++STATIC_LIBS = $(PTHREAD_LIBS) $(SELINUX_STATIC_LIBS) $(UDEV_STATIC_LIBS)
+ DEFS += @DEFS@
+ # FIXME set this only where it's needed, not globally?
+ CFLAGS ?= @COPTIMISE_FLAG@ @CFLAGS@
+@@ -71,8 +71,10 @@
+ READLINE_LIBS = @READLINE_LIBS@
+ EDITLINE_LIBS = @EDITLINE_LIBS@
+ SELINUX_LIBS = @SELINUX_LIBS@
++SELINUX_STATIC_LIBS = @SELINUX_STATIC_LIBS@
+ UDEV_CFLAGS = @UDEV_CFLAGS@
+ UDEV_LIBS = @UDEV_LIBS@
++UDEV_STATIC_LIBS = @UDEV_STATIC_LIBS@
+ BLKID_CFLAGS = @BLKID_CFLAGS@
+ BLKID_LIBS = @BLKID_LIBS@
+ LIBSYSTEMD_LIBS = @LIBSYSTEMD_LIBS@
+--- a/make.tmpl.in
++++ b/make.tmpl.in
+@@ -59,7 +59,7 @@
+ LIBS += @LIBS@ $(SELINUX_LIBS) $(UDEV_LIBS) $(RT_LIBS) $(M_LIBS)
+ LVMLIBS = $(DMEVENT_LIBS) $(READLINE_LIBS) $(EDITLINE_LIBS) 
$(LIBSYSTEMD_LIBS) $(BLKID_LIBS) $(AIO_LIBS) $(LIBS)
+ # Extra libraries always linked with static binaries
+-STATIC_LIBS = $(PTHREAD_LIBS)
++STATIC_LIBS = $(PTHREAD_LIBS) $(SELINUX_STATIC_LIBS) $(UDEV_STATIC_LIBS) 
$(BLKID_STATIC_LIBS) $(M_LIBS)
+ DEFS += @DEFS@
+ # FIXME set this only where it's needed, not globally?
+ CFLAGS ?= @COPTIMISE_FLAG@ @CFLAGS@
+@@ -79,6 +79,7 @@
+ AIO_LIBS = @AIO_LIBS@
+ BLKID_CFLAGS = @BLKID_CFLAGS@
+ BLKID_LIBS = @BLKID_LIBS@
++BLKID_STATIC_LIBS = @BLKID_STATIC_LIBS@
+ CPG_CFLAGS = @CPG_CFLAGS@
+ CPG_LIBS = @CPG_LIBS@
+ EDITLINE_CFLAGS = @EDITLINE_CFLAGS@
+@@ -97,8 +98,10 @@
+ READLINE_CFLAGS = @READLINE_CFLAGS@
+ READLINE_LIBS = @READLINE_LIBS@
+ SELINUX_LIBS = @SELINUX_LIBS@
++SELINUX_STATIC_LIBS = @SELINUX_STATIC_LIBS@
+ UDEV_CFLAGS = @UDEV_CFLAGS@
+ UDEV_LIBS = @UDEV_LIBS@
++UDEV_STATIC_LIBS = @UDEV_STATIC_LIBS@
+ VALGRIND_CFLAGS = @VALGRIND_CFLAGS@
+ VALGRIND_LIBS = @VALGRIND_LIBS@
+ 

diff --git a/sys-fs/lvm2/lvm2-2.03.19.ebuild b/sys-fs/lvm2/lvm2-2.03.19.ebuild
new file mode 100644
index 000000000000..f318272b48ea
--- /dev/null
+++ b/sys-fs/lvm2/lvm2-2.03.19.ebuild
@@ -0,0 +1,306 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+TMPFILES_OPTIONAL=1
+inherit autotools linux-info systemd toolchain-funcs tmpfiles udev flag-o-matic
+
+DESCRIPTION="User-land utilities for LVM2 (device-mapper) software"
+HOMEPAGE="https://sourceware.org/lvm2/";
+SRC_URI="https://sourceware.org/ftp/lvm2/${PN^^}.${PV}.tgz";
+S="${WORKDIR}/${PN^^}.${PV}"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux"
+IUSE="lvm lvm2create-initrd readline sanlock selinux static static-libs 
systemd thin +udev"
+REQUIRED_USE="
+       static? ( !systemd !udev )
+       static-libs? ( static !udev )
+       systemd? ( udev )
+       thin? ( lvm )"
+
+DEPEND_COMMON="
+       udev? ( virtual/libudev:= )
+       lvm? (
+               dev-libs/libaio
+               sys-apps/util-linux
+               readline? ( sys-libs/readline:= )
+               sanlock? ( sys-cluster/sanlock )
+               systemd? ( sys-apps/systemd:= )
+       )"
+# /run is now required for locking during early boot. /var cannot be assumed to
+# be available -- thus, pull in recent enough baselayout for /run.
+# This version of LVM is incompatible with cryptsetup <1.1.2.
+RDEPEND="${DEPEND_COMMON}
+       >=sys-apps/baselayout-2.2
+       lvm? (
+               virtual/tmpfiles
+               lvm2create-initrd? ( sys-apps/makedev )
+               thin? ( sys-block/thin-provisioning-tools )
+       )"
+# note: thin- 0.3.0 is required to avoid --disable-thin_check_needs_check
+DEPEND="${DEPEND_COMMON}
+       static? (
+               lvm? (
+                       dev-libs/libaio[static-libs]
+                       sys-apps/util-linux[static-libs]
+                       readline? ( sys-libs/readline[static-libs] )
+               )
+               selinux? ( sys-libs/libselinux[static-libs] )
+       )"
+BDEPEND="
+       sys-devel/autoconf-archive
+       virtual/pkgconfig"
+
+PATCHES=(
+       # Gentoo specific modification(s):
+       "${FILESDIR}"/${PN}-2.03.17-example.conf.in.patch
+
+       # For upstream -- review and forward:
+       "${FILESDIR}"/${PN}-2.02.56-lvm2create_initrd.patch
+       "${FILESDIR}"/${PN}-2.02.67-createinitrd.patch #301331
+       "${FILESDIR}"/${PN}-2.03.17-locale-muck.patch #330373
+       "${FILESDIR}"/${PN}-2.03.19-dynamic-static-ldflags.patch #332905
+       "${FILESDIR}"/${PN}-2.03.19-static-pkgconfig-libs.patch #370217, 
#439414 + blkid, #617756
+       "${FILESDIR}"/${PN}-2.03.17-pthread-pkgconfig.patch #492450
+       "${FILESDIR}"/${PN}-2.03.19-dmeventd-no-idle-exit.patch
+       "${FILESDIR}"/${PN}-2.03.19-freopen-musl.patch
+)
+
+pkg_setup() {
+       local CONFIG_CHECK="~SYSVIPC"
+
+       if use udev; then
+               local WARNING_SYSVIPC="CONFIG_SYSVIPC:\tis not set (required 
for udev sync)\n"
+               if linux_config_exists; then
+                       local uevent_helper_path=$(linux_chkconfig_string 
UEVENT_HELPER_PATH)
+                       if [[ -n "${uevent_helper_path}" ]] && [[ 
"${uevent_helper_path}" != '""' ]]; then
+                               ewarn "It's recommended to set an empty value 
to the following kernel config option:"
+                               ewarn 
"CONFIG_UEVENT_HELPER_PATH=${uevent_helper_path}"
+                       fi
+               fi
+       fi
+
+       check_extra_config
+
+       # 1. Genkernel no longer copies /sbin/lvm blindly.
+       if use static; then
+               elog "Warning, we no longer overwrite /sbin/lvm and 
/sbin/dmsetup with"
+               elog "their static versions. If you need the static binaries,"
+               elog "you must append .static to the filename!"
+       fi
+}
+
+src_prepare() {
+       default
+
+       # Users without systemd get no auto-activation of any logical volume
+       if ! use systemd ; then
+               eapply "${FILESDIR}"/${PN}-2.03.19-dm_lvm_rules_no_systemd.patch
+       fi
+
+       eautoreconf
+}
+
+src_configure() {
+       filter-flags -flto
+
+       # Workaround for bug #822210
+       tc-ld-disable-gold
+
+       # Most of this package does weird stuff.
+       # The build options are tristate, and --without is NOT supported
+       # options: 'none', 'internal', 'shared'
+       local myeconfargs=(
+               $(use_enable lvm dmfilemapd)
+               $(use_enable lvm dmeventd)
+               $(use_enable lvm cmdlib)
+               $(use_enable lvm fsadm)
+               $(use_enable lvm lvmpolld)
+
+               # This only causes the .static versions to become available
+               $(usev static --enable-static_link)
+
+               # dmeventd requires mirrors to be internal, and snapshot 
available
+               # so we cannot disable them
+               --with-mirrors="$(usex lvm internal none)"
+               --with-snapshots="$(usex lvm internal none)"
+       )
+
+       if use lvm && use thin; then
+               myeconfargs+=( --with-thin=internal --with-cache=internal )
+               local texec
+               for texec in check dump repair restore; do
+                       myeconfargs+=( 
--with-thin-${texec}="${EPREFIX}"/sbin/thin_${texec} )
+                       myeconfargs+=( 
--with-cache-${texec}="${EPREFIX}"/sbin/cache_${texec} )
+               done
+       else
+               myeconfargs+=( --with-thin=none --with-cache=none )
+       fi
+
+       myeconfargs+=(
+               # musl doesn't do symbol versioning so can end up with
+               # runtime breakage.
+               --with-symvers=$(usex elibc_glibc 'gnu' 'no')
+               $(use_enable readline)
+               $(use_enable selinux)
+               --enable-pkgconfig
+               --with-confdir="${EPREFIX}"/etc
+               --exec-prefix="${EPREFIX}"
+               --sbindir="${EPREFIX}/sbin"
+               --with-staticdir="${EPREFIX}"/sbin
+               --libdir="${EPREFIX}/$(get_libdir)"
+               --with-usrlibdir="${EPREFIX}/usr/$(get_libdir)"
+               --with-default-dm-run-dir=/run
+               --with-default-run-dir=/run/lvm
+               --with-default-locking-dir=/run/lock/lvm
+               --with-default-pid-dir=/run
+               $(use_enable udev udev_rules)
+               $(use_enable udev udev_sync)
+               $(use_with udev udevdir "${EPREFIX}$(get_udevdir)"/rules.d)
+               # USE=sanlock requires USE=lvm
+               $(use_enable $(usex lvm sanlock lvm) lvmlockd-sanlock)
+               $(use_enable systemd notify-dbus)
+               $(use_enable systemd app-machineid)
+               $(use_enable systemd systemd-journal)
+               $(use_with systemd systemd-run "/usr/bin/systemd-run")
+               --with-systemdsystemunitdir="$(systemd_get_systemunitdir)"
+               CLDFLAGS="${LDFLAGS}"
+       )
+
+       econf "${myeconfargs[@]}"
+}
+
+src_compile() {
+       emake V=1 -C include
+
+       if use lvm ; then
+               emake V=1
+               emake V=1 CC="$(tc-getCC)" -C scripts
+       else
+               emake V=1 device-mapper
+               # https://bugs.gentoo.org/878131
+               emake V=1 -C libdm/dm-tools device-mapper
+       fi
+}
+
+src_test() {
+       einfo "Tests are disabled because of device-node mucking, if you want 
to"
+       einfo "run tests, compile the package and see ${S}/tests"
+}
+
+src_install() {
+       local INSTALL_TARGETS=(
+               # full LVM2
+               $(usev lvm "install install_tmpfiles_configuration")
+               # install systemd related files only when requested, bug #522430
+               $(usev $(usex lvm systemd lvm) 
"SYSTEMD_GENERATOR_DIR=$(systemd_get_systemgeneratordir) install_systemd_units 
install_systemd_generators")
+
+               # install dm unconditionally
+               install_device-mapper
+       )
+       emake V=1 DESTDIR="${D}" "${INSTALL_TARGETS[@]}"
+
+       newinitd "${FILESDIR}"/device-mapper.rc-2.02.105-r2 device-mapper
+       newconfd "${FILESDIR}"/device-mapper.conf-1.02.22-r3 device-mapper
+
+       if use lvm ; then
+               newinitd "${FILESDIR}"/dmeventd.initd-2.02.184-r2 dmeventd
+               newinitd "${FILESDIR}"/lvm.rc-2.02.187 lvm
+               newconfd "${FILESDIR}"/lvm.confd-2.02.184-r3 lvm
+               if ! use udev ; then
+                       # We keep the variable but remove udev from it.
+                       sed -r -i \
+                               -e '/^rc_need=/s/\<udev\>//g' \
+                               "${ED}"/etc/conf.d/lvm || die "Could not drop 
udev from rc_need"
+               fi
+
+               newinitd "${FILESDIR}"/lvm-monitoring.initd-2.02.105-r2 
lvm-monitoring
+               newinitd "${FILESDIR}"/lvmpolld.initd-2.02.183 lvmpolld
+
+               if use lvm2create-initrd; then
+                       dosbin scripts/lvm2create_initrd/lvm2create_initrd
+                       doman scripts/lvm2create_initrd/lvm2create_initrd.8
+                       newdoc scripts/lvm2create_initrd/README 
README.lvm2create_initrd
+               fi
+
+               if use sanlock; then
+                       newinitd "${FILESDIR}"/lvmlockd.initd-2.02.166-r1 
lvmlockd
+               fi
+       fi
+
+       if use static-libs; then
+               dolib.a libdm/ioctl/libdevmapper.a
+               if use lvm; then
+                       # depends on lvmetad
+                       dolib.a libdaemon/client/libdaemonclient.a #462908
+                       # depends on dmeventd
+                       dolib.a daemons/dmeventd/libdevmapper-event.a
+               fi
+       else
+               rm -f 
"${ED}"/usr/$(get_libdir)/{libdevmapper-event,liblvm2cmd,liblvm2app,libdevmapper}.a
 || die
+       fi
+
+       insinto /etc
+       doins "${FILESDIR}"/dmtab
+
+       dodoc README VERSION* WHATS_NEW WHATS_NEW_DM doc/*.{c,txt} conf/*.conf
+}
+
+pkg_preinst() {
+       HAD_LVM=0
+
+       if has_version 'sys-fs/lvm2[lvm(+)]' ; then
+               HAD_LVM=1
+       fi
+}
+
+pkg_postinst() {
+       use lvm && tmpfiles_process lvm2.conf
+       use udev && udev_reload
+
+       # This is a new installation
+       if [[ -z "${REPLACING_VERSIONS}" ]]; then
+               if use lvm ; then
+                       ewarn "Make sure the \"lvm\" init script is in the 
runlevels:"
+                       ewarn "# rc-update add lvm boot"
+                       ewarn
+                       ewarn "Make sure to enable lvmetad in 
${EROOT}/etc/lvm/lvm.conf if you want"
+                       ewarn "to enable lvm autoactivation and metadata 
caching."
+               else
+                       ewarn "Please enable USE=lvm if you need the LVM daemon 
and"
+                       ewarn "tools like 'lvchange', 'vgchange', etc!"
+               fi
+       else
+               if ! use lvm && [[ ${HAD_LVM} -eq 1 ]] ; then
+                       ewarn "LVM was previously enabled but is now disabled."
+                       ewarn "Please enable USE=lvm if you need the LVM daemon 
and"
+                       ewarn "tools like 'lvchange', 'vgchange', etc!"
+                       ewarn "See the 2022-11-19-lvm2-default-USE-flags news 
item for more details."
+               fi
+       fi
+
+       if use udev && [[ -d /run ]] ; then
+               local permission_run_expected="drwxr-xr-x"
+               local permission_run=$(stat -c "%A" /run)
+               if [[ "${permission_run}" != "${permission_run_expected}" ]] ; 
then
+                       ewarn "Found the following problematic permissions:"
+                       ewarn ""
+                       ewarn "    ${permission_run} /run"
+                       ewarn ""
+                       ewarn "Expected:"
+                       ewarn ""
+                       ewarn "    ${permission_run_expected} /run"
+                       ewarn ""
+                       ewarn "This is known to cause problems for udev-enabled 
LVM services."
+               fi
+       fi
+}
+
+pkg_postrm() {
+       if use udev && [[ -z ${REPLACED_BY_VERSION} ]]; then
+               udev_reload
+       fi
+}

Reply via email to